<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
<script src="axios.min.js"></script>
<script>
    axios.get('https://swapi.dev/api/films/').then(({data}) => {
        const {results} = data;
        results.forEach(({title, characters, episode_id, opening_crawl}) => {
            const container = document.createElement("div")
            document.body.append(container)
            const filmList = document.createElement('ul')
            let charactersList = []
            let charactersItems = []
            characters.forEach(item => charactersItems.push(item))
            const requests = charactersItems.map(item => axios.get(item))
            Promise.all(requests).then(res => {
                res.forEach(({data}) => {
                    const {name} = data
                    charactersList.push(`<li>${name}</li>`)
                    filmList.innerHTML = `<li>Film title : ${title}</li>
                                        <li>Episode : ${episode_id}</li>
                                        <li>Opening crawl : ${opening_crawl}</li>
                                        <li>Characters :
                                        <ul>${charactersList.join('')}</ul>
                                                      </li>`
                    container.append(filmList)
                })
            })
        })
    }).catch(error => console.log(error));


    //
    // const req = fetch('https://swapi.dev/api/films/')
    // req.then(resp => {
    //     if (!resp.ok) {
    //         throw new Error('ooops, something went wrong')
    //     }
    //     return resp.json()
    // }).then(({results}) => {
    //     results.forEach(({title, characters, episode_id, opening_crawl}) => {
    //         const container = document.createElement("div")
    //         document.body.append(container)
    //         const filmList = document.createElement('ul')
    //         let charactersList = []
    //         let charactersItems = []
    //         characters.forEach(item => charactersItems.push(item))
    //         let requests = charactersItems.map(url => fetch(url))
    //         Promise.all(requests).then(responses => Promise.all(responses.map(r => r.json()))).then(elem => elem.forEach(({name}) => {
    //             charactersList.push(`<li>${name}</li>`)
    //             filmList.innerHTML = `<li>Film title : ${title}</li>
    //                                     <li>Episode : ${episode_id}</li>
    //                                     <li>Opening crawl : ${opening_crawl}</li>
    //                                     <li>Characters :
    //                                        <ul>${charactersList.join('')}</ul>
    //                                        </li>`
    //             container.append(filmList)
    //         }))
    //     })
    // }).catch(error => console.log(error))

</script>
</body>
</html>